-- MangosDungeonBrowser Core
-- Code by Kenuvis
-- Last Update: 24.03.2011

-- Version des MDB, aber das ist nicht gleich die Setting Version
MDB.Version = tonumber(GetAddOnMetadata("MDB", "Version"))

-- Prefix, welches beim Senden im Addonchannel verwendet wird
MDB.Prefix = "mdb"

-- suchende Dungeons
MDB.Dungeons = {}

-- aktive DungeonID
MDB.ActiveDungeonID = 0

-- durch Gruppenlevel erstellte Locklist
MDB.CustomLockList = {}

-------------------------------------
---- Errorhandler -------------------
-------------------------------------

-- Trifft ein Fehler einkommende Events auf, wird der MDB sich selbststndig abmelden.
-- Man kann das ausstellen, davon rate ich aber dringlichst ab!
local ignoreError = false

function MDB_Error(Status, ErrMsg)
	if Status == false and not ignoreError then -- Error eingetroffen
		print("Mangos-DungeonBrowser: Fehler! Bitte melden Sie sich im Forum.")
		print(ErrMsg)
		print("Mangos-DungeonBrowser: Aus Schutz werden Sie nun abgemeldet. Sie können sich erneut anmelden, sollte der Fehler weiterhin auftreten, wird dringend geraten, sich bei Ihrer Administration zu melden.")
		LeaveLFG()
	end
end

-------------------------------------
---- Mischandler --------------------
-------------------------------------

local MDB_Misc = CreateFrame("Frame")
MDB_Misc:RegisterEvent("PLAYER_LOGOUT")
MDB_Misc:RegisterEvent("PLAYER_LEVEL_UP")
MDB_Misc:RegisterEvent("CHAT_MSG_CHANNEL_LEAVE")
--MDB_Misc:RegisterEvent("CHAT_MSG_CHANNEL_JOIN")
MDB_Misc:SetScript("OnEvent", function(self, event, ...)
		if event == "PLAYER_LOGOUT" then
			if MDB.ActiveDungeonID ~= 0 then
				LeaveLFG()
			end
			
		elseif event == "PLAYER_LEVEL_UP" then
			MDB.Randomdungeon = {}
			for k,v in pairs({258,259,260,261,262}) do
				if not MDB_DungeonLock(v, UnitLevel("player")) then
					table.insert(MDB.Randomdungeon, v)
				end
			end
			
			LFGEventFrame_OnEvent(LFGEventFrame, "LFG_UPDATE")
			LFGEventFrame_OnEvent(LFGEventFrame, "LFG_UPDATE_RANDOM_INFO")
			
		elseif event == "CHAT_MSG_CHANNEL_LEAVE" then
			-- Wenn Leute mit einem Error (Alt+F4) fliegen, verlassen sie ja trotzdem den Channel
			if select(9,...) == MDB.Channel then
				local Name = select(2,...)
				
				debugprint("Player Offline: "..Name)
				-- triggere ich mich mal selber
				MDB_Event:leave(nil, Name)
			end
		end
	end)

-------------------------------------
---- Chathandler --------------------
-------------------------------------

function MDB_SystemMessage(msg, ...)
	if not msg then
		return
	else
		msg = string.format(msg, ...)
	end

	SendSystemMessage(msg)

--[[
	local a = 1
	while _G["ChatFrame"..a] do
		for _,msgtype in pairs(_G["ChatFrame"..a].messageTypeList) do
			if msgtype == "SYSTEM" then
				ChatFrame_OnEvent(_G["ChatFrame"..a], "CHAT_MSG_SYSTEM", msg,_,_,"")
			end
		end
		a = a+1
	end]]
end

local MDB_IncommingEvent = CreateFrame("Frame")
MDB_IncommingEvent:RegisterEvent("CHAT_MSG_ADDON")
MDB_IncommingEvent:RegisterEvent("CHAT_MSG_CHANNEL")

MDB_IncommingEvent:SetScript("OnEvent", function(self, event, ...)
		if event == "CHAT_MSG_CHANNEL" then
			if select(9, ...) == MDB.Channel then
				local Text = select(1, ...)
				local Sender = select(2, ...)

				if MDB_IsDebug() then
					MDB_IncommingMessage(Text, Sender)
				else
					MDB_Error(pcall(MDB_IncommingMessage, Text, Sender))
				end
			end
			
		elseif event == "CHAT_MSG_ADDON" then
			if select(1, ...) == MDB.Prefix then
				local Text = select(2, ...)
				local Sender = select(4, ...)

				if MDB_IsDebug() then
					MDB_IncommingMessage(Text, Sender)
				else
					MDB_Error(pcall(MDB_IncommingMessage, Text, Sender))
				end
			end
		end
	end)

function MDB_ChannelFilter(...)
	if select(11, ...) == MDB.Channel and not MDB_IsDebug() then
		return true
	end
end
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", MDB_ChannelFilter)

-------------------------------------
---- AutoInvite ---------------------
-------------------------------------

local MDB_InvHook = CreateFrame("Frame")
MDB_InvHook:RegisterEvent("PARTY_INVITE_REQUEST")
MDB_InvHook:RegisterEvent("PARTY_MEMBERS_CHANGED")
MDB_InvHook:SetScript("OnEvent", function(self, event, ...)
		if event == "PARTY_INVITE_REQUEST" then
			local LeaderName = select(1, ...)
			local Dungeon = MDB.Dungeons[MDB.ActiveDungeonID]
			if Dungeon and Dungeon.AcceptInvite and Dungeon:GetPlayerInfo(LeaderName, "GrpLead") then
				AcceptGroup()
				MDB.Dungeons[MDB.ActiveDungeonID].AcceptInvite = nil
				StaticPopup_Hide("PARTY_INVITE")
			end
		elseif event == "PARTY_MEMBERS_CHANGED" then
			if MDB.ActiveDungeonID ~= 0 and MDB.Dungeons[MDB.ActiveDungeonID].Status ~= "lfgparty" then
				-- Wenn der spieler sich im MDB befindet und einer anderen Gruppe beitritt, fliegt er aus dem MDB
				LeaveLFG()
			end
			MDB_CreateCustomLockList()
			LFGEventFrame_OnEvent(nil, "LFG_UPDATE")
		end
	end)

-------------------------------------
---- Eventhandler -------------------
-------------------------------------

MDB_Event = {id = 0}
function MDB_IncommingMessage(Text, Sender)
	if Text == "reloadui" then ReloadUI() return end
	-- ich will ja nicht meine eigenen Nachrichten analysieren
	if Sender == UnitName("player") then return end

	-- geblockte Spieler
	if MDB.IgnorePlayer[Sender] then return end
	if MDB.IgnoreList then
		for a=1,GetNumIgnores() do
			if Sender == GetIgnoreName(a) then
				return
			end
		end
	end

	-- die Textnachricht wird aufgesplittet und zu einem Table gemacht
	local Message = {}
	for a in string.gmatch(Text, ",(%w+)") do
		-- wenn es eine Zahl (id, etc) ist, wird es auch gleich als Zahl gespeichert
		a = tonumber(a) or a
		table.insert(Message, a)
	end

	-- der Eventbezeichner wird rausgenommen und extra gespeichert
	local event = Message[1]
	table.remove(Message, 1)

	-- id wird rausgenommen (wenn ein join, dann id = 0)
	local id = Message[1]
	table.remove(Message, 1)

	debugprint({["event:"]= event, ["id:"]= id})
	debugprint(Message)

	-- da kam wohl ne falsche Message rein
	if not id or not event then return end

	-- abarbeiten der verschiedenen "events"
	if MDB_Event[event] then
		if MDB.Dungeons[id] and MDB.Dungeons[id].enabled then
			MDB.Dungeons[id][event](MDB.Dungeons[id], Message, Sender)
		elseif id == 0 then -- id=0 nur beim z.B. join/leave-Event
			MDB_Event[event](MDB_Event, Message, Sender)
		else
			print("Mangos-DungeonBrowser: Event für nicht ausgewählte Dungeon eingetroffen:")
			local name = select(LFG_RETURN_VALUES.name, GetLFGDungeonInfo(id))
			print(name)
			print(Sender..": "..Text)
			MDB.Dungeons[id]:Send("leave")
		end
	else
		print("Unbehandeltes Event: "..event..":"..id..":"..Text)
		return
	end
end

-------------------------------------
---- interne API --------------------
---- Prototyp Functions -------------
-------------------------------------
MDB_Prototype = {}
MDB_Prototype.id = 0
MDB_Prototype.Player = {}
-- Die Prototype Funktionen leg ich an, um ohne groß auf die IDs eingehen zu müssen
-- die ganzen Funktionen aufrufen zu können, da sie zu dem DungeonArray hinzugefügt werden
-- Die beiden beigefgten Standardwerte vereinfachen es nur an mancher Stelle

function MDB_Prototype:GetPlayerInfo(NameOrPlayerNumber, Return)
	local Name

	if type(NameOrPlayerNumber) == "string" then
		Name = NameOrPlayerNumber
	else
		for n,i in pairs(self.Player) do
			if i.PlayerNumber == NameOrPlayerNumber then
				Name = n
			end
		end
	end

	-- falls die Spielernummer nicht gltig oder der Spieler nicht in der Dungeon eingetragen ist
	if not Name or not self.Player[Name] then return end

	return self.Player[Name][Return]
end

function MDB_Prototype:SetPlayerInfo(NameOrPlayerNumber, key, value)
	local Name

	if type(NameOrPlayerNumber) == "string" then
		Name = NameOrPlayerNumber
	else
		for n,i in pairs(self.Player) do
			if i.PlayerNumber == NameOrPlayerNumber then
				Name = n
			end
		end
	end

	-- falls die Spielernummer nicht gltig oder der Spieler nicht in der Dungeon eingetragen ist
	if not Name or not self.Player[Name] then return end

	self.Player[Name][key] = value
end

function MDB_Prototype:GetPlayerCount()
	local c = 0
	for _ in pairs(self.Player) do
		c = c + 1
	end
	return c
end

function MDB_Prototype:GetReservationCount()
	local c = 0
	for _ in pairs(self.rPlayer) do
		c = c + 1
	end
	return c
end

function MDB_Prototype:AddReservation(Name)
	self.rPlayer[Name] = true
end

function MDB_Prototype:GetReservation(Name)
	return self.rPlayer[Name]
end

function MDB_Prototype:AddPlayerToDungeonQueue(Name, Leader, Tank, Healer, DPS, PlayerNumber, MainRole)
	self.Player[Name] = {
		Name = Name,
		PlayerNumber = PlayerNumber or self:GetPlayerCount()+1,
		Lead = Leader,
		Tank = Tank,
		Heal = Healer,
		DPS = DPS,
		MainRole = MainRole}
end

function MDB_Prototype:RemoveReservation()
	self.rPlayer = {}
end

function MDB_Prototype:RemovePlayerFromDungeonQueue(Name)
	if not self.Player[Name] then return false end

	self.Player[Name] = nil
	
	-- Die Spielernummern werden neu vergeben
	local count = 1
	for name in pairs(self.Player) do
		self:SetPlayerInfo(name, "PlayerNumber", count)
		count = count + 1
	end

	-- Falls ein Spieler whrend des Proposal oder Rolecheck entfernt wird
	if self.Status == "proposal" then
		self:RdyCheckFinish(false)
	elseif self.Status == "rolecheck" then
		self:FinishRoleCheck(false)
	end

	return true
end

function MDB_Prototype:Send(Event, Message, WhisperTo)
	-- das Komma nur am Anfang, damit ich es einfacher später wieder teilen kann
	local SendString = ","..Event..","..self.id

	if Message then
		SendString = SendString..","..Message
	end

	if WhisperTo then
		-- Falls das WhisperTo als PlayerNumber übergeben wurde
		WhisperTo = self:GetPlayerInfo(WhisperTo, "Name") or WhisperTo

		SendAddonMessage(MDB.Prefix, SendString, "WHISPER", WhisperTo)
		return
	end

	--[[if not MDB.ChannelID or MDB.ChannelID == 0 then
		JoinChannelByName(MDB.Channel, MDB.ChannelPassword)
		MDB.ChannelID = GetChannelName(MDB.Channel)
		MDB_StopUhr:Start(SendString, 3, function() self:Send(Event, Message, WhisperTo) end)
		return
	end]]

	JoinChannelByName(MDB.Channel, MDB.ChannelPassword)
	MDB.ChannelID = GetChannelName(MDB.Channel)

	SendChatMessage(SendString, "CHANNEL", nil, MDB.ChannelID)
end

function MDB_Prototype:SendGroup(Event, Message)
	for name in pairs(self.Player) do
		if name ~= UnitName("player") then
			self:Send(Event, Message, name)
		end
	end
end

-- Konvertiert die Informationen über die Rollen und den Namen
-- zu einem String oder mit "back" wieder zurück
function MDB_Prototype:ConvertPlayerInfo(name, back)
	if name == "myself" then
		local str = table.concat({	MDB_Roles.Leader,
									MDB_Roles.Tank,
									MDB_Roles.Healer,
									MDB_Roles.DPS,
									UnitName("player")},"")
		return str
	elseif back then
		local Roles, name = string.match(name, "(%d+)(%w+)")
		local leader, tank, heal, dps, playernumber,MainRole = string.match(Roles, "(%d)(%d)(%d)(%d)(%d?)(%d?)")
		if MainRole == "1" then MainRole = "TANK" end
		if MainRole == "2" then MainRole = "HEALER" end
		if MainRole == "3" then MainRole = "DAMAGER" end

		return name, tonumber(leader) or 0, tonumber(tank) or 0, tonumber(heal) or 0, tonumber(dps) or 0, tonumber(playernumber), MainRole
	else
		local leader = tostring(self.Player[name].Lead or "0")
		local tank = tostring(self.Player[name].Tank or "0")
		local heal = tostring(self.Player[name].Heal or "0")
		local dps = tostring(self.Player[name].DPS or "0")
		local playernumber = tostring(self.Player[name].PlayerNumber or "0")
		local MainRole = self.Player[name].MainRole or "1"
		if MainRole == "TANK" then MainRole = "1" end
		if MainRole == "HEALER" then MainRole = "2" end
		if MainRole == "DAMAGER" then MainRole = "3" end

		local str = table.concat({leader, tank, heal, dps, playernumber, MainRole, name},"")
		return str
	end
end

function MDB_Prototype:ConvertPlayerList()
	local Playerlist = {}

	for Name in pairs(self.Player) do
		table.insert(Playerlist, self:ConvertPlayerInfo(Name))
	end

	return table.concat(Playerlist,",")
end

-- Rollenverteilung
-- Dient zur Kontrolle, und wenn alles soweit auch passt, werden die Rollen auch so gespeichert,
-- ansonsten bleibt es unverndert
-- gibt 2 Werte zurck, falls es fr die Kontrolle genutzt wird:
-- 1. Status ob die Gruppe so mglich ist true/false
-- 2. Grund (als id), falls es nicht mglich ist
-- 	1 Gruppe ist voll, eine Rolle aber komplett unbesetzt (sollte eigentlich nicht vorkommen)
--	2 Ein Spieler konnte nicht eingesetzt werden (z.B. 2x nur Tank gewhlt, da bleibt halt einer auf der Strecke)
function MDB_Prototype:RoleArrange()
	debugprint("RoleArrange ...")
	-- Nur der Leader darf die Rollen neu verteilen, alle anderen lesen sie nur aus
	if not self.IsLeader then
		debugprint("... as Member")
		self.tankNeed = 1
		self.healNeed = 1
		self.dpsNeed = self.MaxPlayer - self.tankNeed - self.healNeed

		table.foreach(self.Player, function(Name,Player)
			--debugprint(Name..": "..Player.MainRole)
			if Player.MainRole == "TANK" then
				self.tankNeed = self.tankNeed - 1
			elseif Player.MainRole == "HEALER" then
				self.healNeed = self.healNeed - 1
			elseif Player.MainRole == "DAMAGER" then
				self.dpsNeed = self.dpsNeed - 1
			end
		end)

		return
	end
	debugprint("... as Leader")

	local Dungeon = self

	Dungeon.tankNeed = 1
	Dungeon.healNeed = 1
	Dungeon.dpsNeed = self.MaxPlayer - Dungeon.tankNeed - Dungeon.healNeed --3

	tank = {}
	heal = {}
	dps = {}
	table.foreach(Dungeon.Player, function(Name,Roles)
		if Roles.Tank == 1 then
			table.insert(tank, Name)
			debugprint(Name..": Tank")
		end
		if Roles.Heal == 1 then
			table.insert(heal, Name)
			debugprint(Name..": Heal")
		end
		if Roles.DPS == 1 then
			table.insert(dps, Name)
			debugprint(Name..": DD")
		end
	end)

	-- Falls die Gruppe voll, eine Rolle aber komplett unbesetzt ist
	if (self:GetPlayerCount() == self.MaxPlayer) and (#tank == 0 or #heal == 0 or #dps == 0) then
		debugprint("Gruppe voll, aber eine Rolle komplett unbesetzt")
		return false, 1
	end

	local function RemovePlayer(Name,RoleTable)
		table.foreach(RoleTable, function(index,n)
			if Name == n then
				table.remove(RoleTable, index)
			end
		end)
		return RoleTable
	end

	local function TankArrange()
		for a = 1, Dungeon.tankNeed do
			if tank[1] then
				local Name = tank[1]
				Dungeon.Player[Name].MainRole = "TANK"
				debugprint("Tank: "..Name)
				Dungeon.tankNeed = Dungeon.tankNeed - 1
				tank = RemovePlayer(Name,tank)
				heal = RemovePlayer(Name,heal)
				dps = RemovePlayer(Name,dps)
			end
		end
	end

	local function HealArrange()
		for a = 1, Dungeon.healNeed do
			if heal[1] then
				local Name = heal[1]
				Dungeon.Player[Name].MainRole = "HEALER"
				debugprint("Heal: "..Name)
				Dungeon.healNeed = Dungeon.healNeed - 1
				tank = RemovePlayer(Name,tank)
				heal = RemovePlayer(Name,heal)
				dps = RemovePlayer(Name,dps)
			end
		end
	end

	-- erstmal: Tank und Heal sind wichtiger als DPS
	-- ganz witzig: Je nachdem, welche Rollen weniger gewählt wurden,
	-- wird diese Rolle dann zuerst behandelt.
	if #heal > #tank then
		TankArrange()
		HealArrange()
	else
		HealArrange()
		TankArrange()
	end

	for a = 1, Dungeon.dpsNeed do
		if dps[1] then
			local Name = dps[1]
			Dungeon.Player[Name].MainRole = "DAMAGER"
			debugprint("DPS: "..Name)
			Dungeon.dpsNeed = Dungeon.dpsNeed - 1
			tank = RemovePlayer(Name,tank)
			heal = RemovePlayer(Name,heal)
			dps = RemovePlayer(Name,dps)
		end
	end

	if #tank ~= 0 or #heal ~= 0 or #dps ~= 0 then
		debugprint("Min. einer zuviel in der Gruppe bzw. eine Rolle ist überbesetzt.")
		return false, 2
	end

	MDB.Dungeons[self.id] = Dungeon
	return true
end

function MDB_Prototype:TriggerGroupUpdate()
	--MDB_QueueUpdate()
	self:RoleArrange()
	local PlayerList = self:ConvertPlayerList()
	self:SendGroup("groupupdate", PlayerList)
end

function MDB_Prototype:TriggerSearch()
	local DungeonForQueue = {}
	for id in pairs(MDB.Dungeons) do
		table.insert(DungeonForQueue, id)
	end

	if #DungeonForQueue > 0 then
		MDB_Prototype:Send("search", table.concat(DungeonForQueue, ","))
	end
end

-- Einladegeschwindigkeit (je nach Server) 1 = 5 Sekunden, 2 = 2,5 Sekunden, ... , 5 = 1 Sekunde
function MDB_Prototype:StartDungeon()
	if self.IsLeader then
		for a=1,self:GetPlayerCount() do
			local name = self:GetPlayerInfo(a, "Name")
			if name ~= UnitName("player") then
				MDB_StopUhr:Start("Inv"..name, a/(5/MDB.InvSpeed), function() InviteUnit(name) end)
			end
		end
	end

	self.AcceptInvite = true
	self.Status = "lfgparty"
end

-------------------------------------
---- Init-Functions -----------------
-------------------------------------

function MDB_InitDungeon(id, enabled)
	-- sollte eigentlich nicht vorkommen, aber sicher ist sicher
	id = tonumber(id)

	local MaxPlayer = select(LFG_RETURN_VALUES.maxPlayers, GetLFGDungeonInfo(id))
	-- RandomDungeons haben ein MaxPlayer von 0 - seltsam
	if MaxPlayer == 0 then MaxPlayer = 5 end
	local Name = select(LFG_RETURN_VALUES.name, GetLFGDungeonInfo(id))
	local typeID = select(LFG_RETURN_VALUES.typeID, GetLFGDungeonInfo(id))
	
	MDB.Dungeons[id] = {	id = id,
					name = Name,
					typeID = typeID,
					enabled = enabled,
					IsLeader = true,
					--Player = {},
					--rPlayer = {},
					tankNeed = 1,
					healNeed = 1,
					dpsNeed = MaxPlayer - 2,
					waittime = GetTime(),
					MaxPlayer = MaxPlayer,
					Status = "queue"}

	-- Prototyp Functions werden nun eingesetzt
	for name,func in pairs(MDB_Prototype) do
		MDB.Dungeons[id][name] = func
	end
	-- Event Functions nun auch
	for name,func in pairs(MDB_Event) do
		MDB.Dungeons[id][name] = func
	end

	MDB.Dungeons[id].id = id
	MDB.Dungeons[id].Player = {}
	MDB.Dungeons[id].rPlayer = {}

	MDB.Dungeons[id]:AddPlayerToDungeonQueue(UnitName("player"), MDB_Roles.Leader, MDB_Roles.Tank, MDB_Roles.Healer, MDB_Roles.DPS)
	MDB.Dungeons[id]:SetPlayerInfo(UnitName("player"), "Class", UnitClass("player"))
	MDB.Dungeons[id]:SetPlayerInfo(UnitName("player"), "Level", UnitLevel("player"))
end

function MDB_RemoveDungeon(id)
	MDB.Dungeons[id] = nil
end

-------------------------------------
---- Stopuhr ------------------------
-------------------------------------

MDB_StopUhr = CreateFrame("Frame")
local TimeTasks = {}
function MDB_StopUhr:Start(name, length, func, echo)
	debugprint("StopUhr:Start "..name)
	TimeTasks[name] = {}
	TimeTasks[name].StartTime = GetTime()
	TimeTasks[name].EndTime = TimeTasks[name].StartTime + length
	TimeTasks[name].Func = func

	-- fr Wiederholung
	TimeTasks[name].Echo = echo
	TimeTasks[name].Length = length

	local MDB_StopUhr_OnUpdate = function()
			for task,info in pairs(TimeTasks) do
				if GetTime() >= TimeTasks[task].EndTime then
					if not TimeTasks[task].Echo then
						TimeTasks[task].Func(task)
						MDB_StopUhr:Stop(task)
					else
						TimeTasks[task].EndTime = GetTime()+TimeTasks[task].Length
						TimeTasks[task].Func(task)
					end
				end
			end
		end

	MDB_StopUhr:SetScript("OnUpdate", function() pcall(MDB_StopUhr_OnUpdate) end)
end

function MDB_StopUhr:Stop(name)
	debugprint("StopUhr:Stop "..name)
	TimeTasks[name] = nil

	-- Wenn da irgendein Task noch drin ist, stopuhr nicht anhalten
	for task in pairs(MDB_StopUhr) do
		if type(task) == "string" then
			return
		end
	end
	MDB_StopUhr:SetScript("OnUpdate", nil)
end

function MDB_StopUhr:StopAll()
	TimeTasks = {}
	MDB_StopUhr:SetScript("OnUpdate", nil)
end
