﻿-- MangosDungeonBrowser Hack
-- Code by Kenuvis
-- Last Update: 24.03.2011

--[[
Von der Logik her:
Jeder Spieler der den DB nutzt, sendet beim "suchen" eine Nachricht
in den eigenst dafür vorgesehen Channel mit seiner DungeonID und seiner Rolle.
Sucht ein anderer auch diese DungeonID und passt es mit der Rolle,
so übernimmt dieser den "Server"/"Leader" für diese eine Dungeon.
]]

MDB_Roles = {}

-- Falls der MDB von Anfangan ausgeschaltet ist (z.B. weil auf einem anderen Server)
-- wird der Functionhack auch nicht getan, vlt unterstützt der Server den Dungeonbrowser
if MDB.Enable then

	-- Da das mit der Belohnung für eine Randomdungeon eh nicht geht, einfach weg
	local rFrame = "LFDQueueFrameRandomScrollFrameChildFrame"
	_G[rFrame.."Description"]:SetText("Oben rechts in der Box bitte den Typ eures Auswahlkriterium für die Instanzen wählen.")
	_G[rFrame.."RewardsLabel"]:SetText("Mangos-DungeonBrowser")
	_G[rFrame.."PUGDescription"]:SetText("UICode: Blizzard Entertainment\nCoreCode: Kenuvis\n\nVersion: "..MDB.Version.."\nLetztes Update: 24.03.2011")
	_G[rFrame.."RewardsDescription"]:Hide()
	_G[rFrame.."MoneyLabel"]:Hide()
	_G[rFrame.."XPLabel"]:Hide()
	_G[rFrame.."XPAmount"]:Hide()
	_G[rFrame.."Item1"]:Hide()
	_G[rFrame.."MoneyFrame"]:Hide()

	function GetLFGInfoServer()
		debugprint("#GetLFGInfoServer")

		local Dungeon = MDB.Dungeons[MDB.ActiveDungeonID]

		local inParty = UnitInParty("player")
		local joined = nil -- Dem Raidbrowser begetreten
		-- Wenn eine Dungeon ausgewahlt ist, ist man auch im Queue
		local queued = (MDB.ActiveDungeonID ~= 0 and MDB.Dungeons[MDB.ActiveDungeonID].Status == "queue")
		local noPartialClear = nil
		local achievements = 0
		local lfgComment = "test"
		local slotCount = (Dungeon ~= nil and Dungeon.MaxPlayer) or 5

		return inParty, joined, queued, noPartialClear, achievements, lfgComment, slotCount
	end

	function IsListedInLFR()
		debugprint("#IsListedInLFR")

		return
	end

	function IsPartyLFG()
		debugprint("#IsPartyLFG")

		if MDB.ActiveDungeonID == 0 then
			return
		end

		return (MDB.Dungeons[MDB.ActiveDungeonID].Status == "lfgparty")
	end

	function IsInLFGDungeon()
		debugprint("#IsInLFGDungeon")

		if MDB.ActiveDungeonID == 0 then
			return
		end

		return (MDB.Dungeons[MDB.ActiveDungeonID].Status == "lfgparty")
	end

	function HasLFGRestrictions()
		debugprint("#HasLFGRestrictions")

		if MDB.ActiveDungeonID == 0 then
			return
		end

		local Dungeon = MDB.Dungeons[MDB.ActiveDungeonID]

		return (Dungeon.Status == "lfgparty")
	end

	function UnitGroupRolesAssigned(Unit)
		debugprint("#UnitGroupRolesAssigned")

		local role
		if MDB.Dungeons[MDB.ActiveDungeonID] then
			role = MDB.Dungeons[MDB.ActiveDungeonID]:GetPlayerInfo(UnitName(Unit), "MainRole")
		end

		return role
	end

	-- Ist die Gruppe "fähig" weitere Member zu inviten
	function CanPartyLFGBackfill()
		debugprint("#CanPartyLFGBackfill")

		local CanDo = nil

		if GetLFGMode() == "lfgparty" then
			CanDo = 1
		end

		local MaxPlayer = select(LFG_RETURN_VALUES.maxPlayers, GetLFGDungeonInfo(MDB.ActiveDungeonID))
		-- -1 da man sich selber nicht mitzählt
		if MDB.ActiveDungeonID == 0 or GetNumPartyMembers() == MaxPlayer-1 then
			CanDo = nil
		end

		return CanDo
	end

	-- Informationen über das weitere Einladen von Player
	function GetPartyLFGBackfillInfo()
		debugprint("#GetPartyLFGBackfillInfo")

		-- Absolut keine Ahnung, muss ich mal sehen
		local name = select(LFG_RETURN_VALUES.name, GetLFGDungeonInfo(MDB.ActiveDungeonID))
		local lfgID = MDB.ActiveDungeonID
		local typeID = select(LFG_RETURN_VALUES.typeID, GetLFGDungeonInfo(MDB.ActiveDungeonID))

		return name, lfgID, typeID
	end

	function PartyLFGStartBackfill()
		debugprint("#PartyLFGStartBackfill")
		print("Mangos-Dungeonbrowser: Diese Funktion ist zum derzeitigen Entwicklungsstand noch nicht zugänglich.")
	end

	-- ist bereits in UIParent.lua gescriptet
	-- Die wohl wichtigeste Funktion imo. Gibt den aktuellen Status an.
	--[[function GetLFGMode()
		--debugprint("#GetLFGMode")

		-- abandonedInDungeon - Gruppe löst sich auf, Spieler ist aber noch in Dungeon
		-- lfgparty - Dungeon in progress
		-- proposal - grp hat sich gebildet, rdycheck
		-- rolecheck - Spieler werden aufgefordert, ihre Rolle zu wählen
		-- queued - im LFG Queue
		-- listed - keine Ahnung
		-- nil - nicht im dungeonbrowser
		local mode = MDB.mode

		-- unempowered - standard im LFG
		-- empowered - wenn ein Spieler den LFG verweigert
		-- nil - falls nicht für mehr spieler gesucht wird
		local submode = MDB.submode

		return mode, submode
	end]]

	MDB.Randomdungeon = {}
	for k,v in pairs({258,259,260,261,262}) do
		if not MDB_DungeonLock(v, UnitLevel("player")) then
			table.insert(MDB.Randomdungeon, v)
		end
	end

	function GetNumRandomDungeons()
		-- weil noch nicht getestet/gescriptet
		return #MDB.Randomdungeon
	end

	function GetLFGRandomDungeonInfo(Index)
		debugprint("#GetLFGRandomDungeonInfo"..Index)

		local id = MDB.Randomdungeon[Index]
		local name = select(LFG_RETURN_VALUES.name, GetLFGDungeonInfo(id))

		return id, name
	end

	function GetRandomDungeonBestChoice()
		debugprint("#GetRandomDungeonBestChoice")
		
		local myLevel = UnitLevel("player")
		local recDungeonID
		local LevelDiff
		for _,id in pairs(MDB.Randomdungeon) do
			local recLevel, minrecLevel, maxrecLevel = select(LFG_RETURN_VALUES.recLevel, GetLFGDungeonInfo(id))
			if LevelDiff or ( math.abs(recLevel - myLevel) < LevelDiff and minrecLevel < myLevel and maxrecLevel > myLevel ) then
				LevelDiff = math.abs(recLevel - myLevel)
				recDungeonID = id
			end
		end

		-- Falls nicht gefunden, 
		if not recDungeonID then
			recDungeonID = MDB.Randomdungeon[math.random(GetNumRandomDungeons())]
		end

		return recDungeonID
	end

	function JoinLFG()
		debugprint("#JoinLFG")

		if MDB_Roles.Tank == 0 and MDB_Roles.Healer == 0 and MDB_Roles.DPS == 0 then
			MDB_SystemMessage(ERR_LFG_NO_ROLES_SELECTED)
			return
		end

		MDB.timeinqueue = GetTime()

		local invalidDungeon
		local DungeonForQueue = {}
		table.foreach(MDB.Dungeons,
			function(id)
				-- Keine Ahnung woher die negativen IDs kommen, aber die müssen weg
				if id > 0 then
					if (MDB.LockList[id] or MDB.CustomLockList[id]) and not MDB_IsDebug() then
						invalidDungeon = true
					else
						table.insert(DungeonForQueue, id)
						MDB.Dungeons[id].enabled = true
					end
				end
			end)

		if invalidDungeon then
			MDB_SystemMessage(ERR_LFG_INVALID_SLOT)
			LFGEventFrame_OnEvent(nil, "LFG_LOCK_INFO_RECEIVED" )
		end

		-- Zufällige Dungeon
		if #DungeonForQueue == 0 then
			--message("Zufällige Dungeons sind zum derzeitigen Entwicklungsstand des Mangos-Dungeonbrowser nicht verfügbar.")
			MDB.Dungeons = {}

			MDB_SystemMessage(ERR_LFG_NO_SLOTS_SELECTED)
			return
		end

		local SendString = table.concat(DungeonForQueue,",")
		-- erzeugt eine 4stellige Nummer, die für die Rollen steht
		-- und fügt alles zusammen
		SendString = MDB_Prototype:ConvertPlayerInfo("myself")..","..SendString

		-- Wenn der RoleCheck läuft darf man dem Queue noch nicht beitreten
		if GetNumPartyMembers() > 0 then
			--MDB_Prototype:StartRoleCheck(SendString)
			LeaveParty()
			MDB_StopUhr:Start("JOIN", 1, JoinLFG)
		elseif GetChannelName(MDB.Channel) == 0 then
			JoinChannelByName(MDB.Channel, MDB.ChannelPassword)
			MDB.ChannelID = GetChannelName(MDB.Channel)
			MDB_StopUhr:Start("JOIN", 1, JoinLFG)
			--MDB_SystemMessage("Mangos-DungeonBrowser: Queue-Anfrage konnte nicht versendet werden. Anfrage wird automatisch in 3 Sekunden erneut gesendet.")
		else
			MDB_Prototype:Send("join", SendString)
			MDB_QueueUpdate()
			MDB_SystemMessage(ERR_LFG_JOINED_QUEUE)
			MDB_StopUhr:Stop("JOIN")
		end
		
		-- SucheNachGruppe-Channel beitreten
		local ChannelList = {EnumerateServerChannels()}
		for _,Channel in pairs(ChannelList) do
			if string.find(Channel, CHANNEL_CATEGORY_GROUP) then
				JoinChannelByName(Channel)
				break
			end
		end
		
		LFGEventFrame_OnEvent(nil, "LFG_UPDATE")
	end

	function LeaveLFG()
		debugprint("#LeaveLFG")
		
		-- Wenn möglich, ernennt der ehemalige Leader einen neuen Leader (Fehlerquelle minimiert)
		for id,dungeon in pairs(MDB.Dungeons) do
			if dungeon.IsLeader and dungeon:GetPlayerCount() > 1 then
				for a=1,dungeon:GetPlayerCount() do
					-- Ein passenden Nachfolger suchen
					if dungeon:GetPlayerInfo(a, "Lead") and dungeon:GetPlayerInfo(a, "Name") ~= UnitName("player") then
						dungeon:SendGroup("moveleader", dungeon:GetPlayerInfo(a, "Name"))
						break
					
					-- Kein passenden Nachfolger gefunden, so wird's einfach der letzte
					elseif a == dungeon:GetPlayerCount() then
						dungeon:SendGroup("moveleader", dungeon:GetPlayerInfo(a, "Name"))
					end
				end
			end
		end
					

		MDB_Prototype:Send("leave")
		MDB.Dungeons = {}
		MDB.ActiveDungeonID = 0
		MDB_StopUhr:StopAll()

		MDB_SystemMessage(ERR_LFG_LEFT_QUEUE)

		LeaveChannelByName(MDB.Channel)
		
		-- SucheNachGruppe-Channel verlassen
		local ChannelList = {EnumerateServerChannels()}
		for _,Channel in pairs(ChannelList) do
			if string.find(Channel, CHANNEL_CATEGORY_GROUP) then
				LeaveChannelByName(Channel)
				break
			end
		end
		
		LFDFrame_OnEvent(nil, "LFG_PROPOSAL_FAILED")
		LFGEventFrame_OnEvent(nil, "LFG_UPDATE")
		--LFDFrame_OnEvent(nil, "LFG_UPDATE_RANDOM_INFO")
	end

	function ClearAllLFGDungeons()
		debugprint("#ClearAllLFGDungeons")
		MDB.Dungeons = {}
		MDB.ActiveDungeonID = 0
	end

	function SetLFGDungeon(DungeonID, enabled)
		debugprint(DungeonID)
		if not DungeonID then
			return
		end
		enabled = enabled or false

		MDB_InitDungeon(DungeonID, enabled)
	end

	function GetLFGQueuedList()
		debugprint("#GetLFGQueuedList")

		LFGQueuedForList = {}
		for a in pairs(MDB.Dungeons) do
			LFGQueuedForList[a] = 1
		end
		return LFGQueuedForList
	end

	function SetLFGRoles(Leader, Tank, Healer, DPS)
		debugprint("#SetLFGRoles")

		MDB_Roles.Leader = (1 and Leader) or 0
		MDB_Roles.Tank = (1 and Tank) or 0
		MDB_Roles.Healer = (1 and Healer) or 0
		MDB_Roles.DPS = (1 and DPS) or 0
	end

	function GetLFGRoles()
		debugprint("#GetLFGRoles")

		return (MDB_Roles.Leader==1), (MDB_Roles.Tank==1), (MDB_Roles.Healer==1), (MDB_Roles.DPS==1)
	end

	function GetLFGQueueStats()
		debugprint("#GetLFGQueueStats")

		local Dungeon = MDB.Dungeons[MDB.ActiveDungeonID]

		local hasData = (MDB.ActiveDungeonID ~= 0)
		local leaderNeeds = false
		local tankNeeds = Dungeon.tankNeed
		local healerNeeds = Dungeon.healNeed
		local dpsNeeds = Dungeon.dpsNeed
		local instanceType = Dungeon.typeID
		local instanceName = Dungeon.Name
		local averageWait = -1
		local tankWait = -1
		local healerWait = -1
		local damageWait = -1
		local myWait = -1 -- erwartete Wartezeit (-1 = nicht errechenbar)
		local queuedTime = Dungeon.waittime

		return hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime
	end

	function GetLFDChoiceLockedState()
		debugprint("#GetLFDChoiceLockedState")
		if MDB_IsDebug() then
			return {}
		end

		-- Falls der Dungeonbrowser aus ist, wird die Locklist zu einer
		-- Metatable, die einfach jeden Index hat, den man abfragt
		if not MDB.Enable then
			return setmetatable({}, {__index = function(_,i) return {[i] = 1} end})
		end

		-- Statische Locklist, da Dungeons vlt nicht gehen (müssen von der Serveradministration freigegeben werden)
		local LockList = MDB.LockList

		-- Die Locklist die durch die Gruppe erzeugt wird
		table.foreach(MDB.CustomLockList, function(i) LockList[i] = 1 end)

		return LockList
	end

	-- Wieviele der aktuellen Gruppe nicht in die Instanz können
	-- 0 = Einfach nur gesperrt
	function GetLFDLockPlayerCount()
		debugprint("#GetLFDLockPlayerCount")
		-- potenziell ist es erstmal die ganze Gruppe, aussortieren mach ich im GetLFDLockInfo
		return GetNumPartyMembers()
	end

	-- und warum
	function GetLFDLockInfo(id, Playercount)
		debugprint("#GetLFDLockInfo")

		local name = UnitName("party"..Playercount)
		local level = UnitLevel("party"..Playercount)
		local lockreason = 6
		if level < select(LFG_RETURN_VALUES.minLevel, GetLFGDungeonInfo(id)) then
			lockreason = 2
		elseif level > select(LFG_RETURN_VALUES.maxLevel, GetLFGDungeonInfo(id)) then
			lockreason = 3
		end

		return name, lockreason --subreason nur für Gearlevel
	end

end