﻿-- MangosDungeonBrowser GeneralFunctions
-- Code by Kenuvis
-- Last Update: 24.03.2011

--[[ todo:
- [Code durchschauen, aufräumen und Abfragen auslagern]
- [Events auslagern um es übersichtlicher zu machen]
- [Rollenverteilung nachbessern]
- [join-event neu]
- [eigene Stopuhr erstellen]
- [>>WER HAT WELCHE DATEN IN WELCHER FORM ???<< -> Alle haben Daten über Name, Rollen und Playernumber]
- [SetPlayerInfo im gesamten Script einarbeiten]
- [Daten über die Gruppe an die Gruppe ausgeben]
- [Multitask bei StopUhr]
- [PlayerCheck (Level und Class abspeichern)} << Buggy ! PlayerCheck erhält von Stopuhr kein Namen und self]
- [Verhalten beim Ausfall des Leaders]
- [rdycheck fertig machen]
- [grpinvite -> Speicher leerräumen]
- [rolecheck fertig machen << Ablehnen und vorzeitiges RoleArrange()]
- [Send richtig machen]
- [Setting Version vergleichen]
- {Code durchschauen und Sachen in Dateien aufteilen}
- [locklist]
- [Randomdungeon & Event bei Levelup]
- [Messages als Sysmsg ausgeben]
- Boss DB erstellen und kill-hook
- [errorhandler richtig machen]
- [AcceptGroup() - Accept the invitation to party.]
- Beitreten als Gruppe (kleinere Gruppen werden zugunsten größerer aufgelöst)
- [Versionsnummer aus der TOC nehmen]
- Wenn ein echtes Gruppenmitglied leave, dann alle der Gruppe auch
- {erweiterter onlinecheck, der auch die aktivität des MDB überprüft (also ReloadUI und alle settings sind weg)}
- id management
]]



-------------------------------------
---- Interaction --------------------
-------------------------------------

-- Solange eine Reservierung aktiv bleibt
-- Eine Reservierung finden zwischen dem Eintragen
-- in den DungeonQueue und dem Bestätigen statt
-- Dient nur zum überbrücken der Latenzzeit
MDB.ReservationWait = 3

-- Das Event wird ausgelöst, wenn jemand dem Dungeonbrowser beitritt
-- Falls der Empfänger die gleiche Dungeon im Queue hat und er der Leader
-- ist, so kann das interne Gruppenbilden beginnen
function MDB_Event:join(Message, Sender)
	-- Falls es eine Gruppe ist
	local Player = {}
	while type(Message[1]) == "string" do
		local Name, Leader, Tank, Healer, DPS = MDB_Prototype:ConvertPlayerInfo(Message[1],true)
		table.insert(Player, {Name, Leader, Tank, Healer, DPS})
		table.remove(Message, 1)
	end

	for _,id in pairs(Message) do
		if MDB.Dungeons[id] then
			local Dungeon = MDB.Dungeons[id]

			if GetLFGMode() == "queued"
			and Dungeon.IsLeader
			and Dungeon.MaxPlayer >= Dungeon:GetPlayerCount() + Dungeon:GetReservationCount() + #Player
			then
				-- Der/Die Spieler wird/werden probeweise hinzugefügt um zu schauen,
				-- ob es überhaupt funktioniert
				for _,p in pairs(Player) do
					Dungeon:AddPlayerToDungeonQueue(p[1], p[2], p[3], p[4], p[5])
					debugprint({p[1], p[2], p[3], p[4], p[5]})
				end
				-- Gruppe funktioniert so, daher kriegt er ein inv
				-- Durch den probeweisen Add bekommt der Spieler schon
				-- eine Liste mit sich selber drin
				if Dungeon:RoleArrange() then
					for _,p in pairs(Player) do
						Dungeon:Send("inpossiblegroup", MDB.Version..","..Dungeon:GetPlayerCount(), p[1])
					end
				end

				-- Bis zur Bestätigung fliegt er/sie erstmal wieder raus
				for _,p in pairs(Player) do
					-- eigentlich nicht nötig, da es nur ein Dummy ist
					Dungeon:RemovePlayerFromDungeonQueue(p[1])

					-- Der Platz wird für genau 3 Sekunden reserviert
					MDB.Dungeons[id]:AddReservation(p[1])
				end

				MDB_StopUhr:Start("reservation", MDB.ReservationWait, function() debugprint("Timer out") MDB.Dungeons[id]:RemoveReservation() end)
			end
		end
	end
end

function MDB_Event:inpossiblegroup(Message,Sender)
	-- Nur wenn es keine echte Gruppe schon gibt und die andere Gruppe größer ist mit mir, als meine jetztige
	-- oder wenn meine Gruppe mit der anderen nicht über 5 Leute sind
	if (not (GetNumPartyMembers() > 0) and Message[2] > self:GetPlayerCount()) or self.MaxPlayer >= Message[2] then
		-- Wo es zu Versionskonflikten kommt, kommt auch keine Gruppe zustande
		if Message[1] ~= MDB.Version then
			local LockCount = 0
			for _ in pairs(MDB.LockList) do
				LockCount = LockCount + 1
			end
			self:Send("versioncheck", MDB.Version..","..MDB.SettingVersion..","..LockCount, Sender)
			return
		end

		-- Falls ich vorher in einer anderen (kleineren) Gruppe war, wird diese verlassen
		if self:GetPlayerCount() > 1 then
			self:SendGroup("leave")
		end

		self:Send("confirmpossiblegroup", self:ConvertPlayerInfo("myself"), Sender)
		self.IsLeader = false
	end
end

-- Spieler hat den internen Inv bestätigt
function MDB_Event:confirmpossiblegroup(Message, Sender)
	-- Timeout der Reservation, Richtigkeit der Gruppe kann so nicht garantiert werden
	if not self:GetReservation(Sender) then
		if self:GetPlayerCount() < self.MaxPlayer then
			-- Falls die Gruppe noch nicht voll ist, bekommt er eine neue chance
			self:Send("search", self.id, Sender)
		end
		return
	end

	local _,Leader, Tank, Healer, DPS = self:ConvertPlayerInfo(Message[1],true)

	self:AddPlayerToDungeonQueue(Sender, Leader, Tank, Healer, DPS)

	-- Die Reservierungen werden gelöscht und die StopUhr angehalten
	self:RemoveReservation()
	MDB_StopUhr:Stop("reservation")
	self:TriggerGroupUpdate()
		
	-- wenn ich leader bin, kein ding, ansonsten der erste, der leader ist
	if MDB_Roles.Leader or Leader == 0 then
		self.IsLeader = true
	else
		self.IsLeader = false
		self:SendGroup("moveleader", Sender)
	end
	MDB_QueueUpdate()	
end

-- Die Nachrichten kommen nur vom GrpLeader, daher Sender == GrpLeader
function MDB_Event:groupupdate(Message, Sender)
	debugprint("groupupdate: "..self.id)
	-- Informationen über die anderen Spieler im Dungeonqueue
	for _,Player in pairs(Message) do
		local Name,Leader,Tank,Healer,DPS,PlayerNumber,MainRole = self:ConvertPlayerInfo(Player,true)
		self:AddPlayerToDungeonQueue(Name, Leader, Tank, Healer, DPS, PlayerNumber, MainRole)
		self:SetPlayerInfo(Name, "GrpUpdate", 1)
		debugprint("+ "..Name)
	end

	table.foreach(self.Player, function(Name)
			if not self:GetPlayerInfo(Name, "GrpUpdate") then
				self:RemovePlayerFromDungeonQueue(Name)
				debugprint("- "..Name)
			else
				self:SetPlayerInfo(Name, "GrpLead", nil)
				self:SetPlayerInfo(Name, "GrpUpdate", nil)
			end
		end)

	debugprint("L "..Sender)
	self:SetPlayerInfo(Sender, "GrpLead", 1)
	if Sender == UnitName("player") then self.IsLeader = true else self.IsLeader = false end

	debugprint("---")
	MDB_QueueUpdate()
end

function MDB_Event:leave(Message, Sender)
	-- Falls das ein allg. leave ist, gilt es für alle Dungeons
	-- und die Funktion wird rekursiv
	if self.id == 0 then
		for id in pairs(MDB.Dungeons) do
			MDB.Dungeons[id]:leave(Message, Sender)
		end
		--MDB_Prototype:TriggerSearch()
		return
	end
	
	local LeaderLeave = self:GetPlayerInfo(Sender, "GrpLead") 

	self:RemovePlayerFromDungeonQueue(Sender)
	
	-- GrpLead ist ausgefallen - Über diesen Weg wird es nur festgestellt, wenn der Leader ein Disco hat
	if LeaderLeave then
		for a = 1, self.GetPlayerCount() do
			local Name = self:GetPlayerInfo(a, "Name")
			if self:GetPlayerInfo(a, "Lead") and Name ~= Sender then
				if Name == UnitName("player") then
					-- mal ganz fein mich wieder selber getriggert
					self:moveleader()
				else
					self:SendGroup("moveleader", Name)
				end
				break
				
			elseif a == self:GetPlayerCount() then
				if Name == UnitName("player") then
					-- mal ganz fein mich wieder selber getriggert
					self:moveleader()
				else
					self:SendGroup("moveleader", Name)
				end
			end
		end
	end					

	MDB_QueueUpdate()
end

-- Das Event bekomme ich nur, wenn ich zum Leader ernannt wurde
function MDB_Event:moveleader(Message, Sender)
	local Name = Message[1]
	
	for a=1,self.MaxPlayer do
		self:SetPlayerInfo(a, "GrpLead", nil)
	end

	self:SetPlayerInfo(Name, "GrpLead", 1)

	if Name == UnitName("player") then
		self.IsLeader = true
		--self:TriggerGroupUpdate()
	end	
end

-- Spieler ist noch online, aber wohl AFK
function MDB_Event:timeout(Message, Sender)
	-- wenn z.B. das Proposal mit einem timeout beendet wird bekommen die AFK-Spieler diese Nachricht
	if Message[1] == "proposal" then
		MDB_SystemMessage(ERR_LFG_PROPOSAL_DECLINED_SELF)
		LFDFrame_OnEvent(nil, "LFG_PROPOSAL_FAILED")
	end

	LeaveLFG()
end

function MDB_Event:versioncheck(Message, Sender)
	local LockCount = 0
	for _ in pairs(MDB.LockList) do
		LockCount = LockCount + 1
	end

	if Message[1] > MDB.Version then
		MDB_SystemMessage("Mangos-DungeonBrowser: "..ADDON_INTERFACE_VERSION)
		if GetLocale() == "deDE" then
			message("Achtung, neuere Mangos-DungeonBrowser Version im Umlauf: "..Message[1])
		else
			message("Attention, newer Mangos-DungeonBrowser Version released: "..Message[1])
		end
	elseif Message[1] < MDB.Version then
		MDB_Prototype:Send("versioncheck", MDB.Version..","..MDB.SettingVersion..","..LockCount, Sender)
	elseif Message[2] > MDB.SettingVersion then
		MDB_SystemMessage("Mangos-DungeonBrowser: "..ADDON_INSECURE)
		if GetLocale() == "deDE" then
			message("Achtung, neuere Mangos-DungeonBrowser Serversettingdatei im Umlauf: "..Message[2])
		else
			message("Attention, newer Mangos-DungeonBrowser Serversettingfile released: "..Message[2])
		end
	elseif Message[2] == MDB.SettingVersion and Message[3] ~= LockCount then
		MDB_SystemMessage("Mangos-DungeonBrowser: "..ADDON_INSECURE)
		if GetLocale() == "deDE" then
			message("Achtung, eine ungültige Mangos-DungeonBrowser Serversettingdatei im Umlauf")
		else
			message("Attention, an invalide Mangos-DungeonBrowser Serversettingfile in action")
		end
		MDB_Prototype:Send("versioncheck", MDB.Version..","..MDB.SettingVersion..","..LockCount, Sender)
	elseif Message[2] < MDB_SettingVersion then
		MDB_Prototype:Send("versioncheck", MDB.Version..","..MDB.SettingVersion..","..LockCount, Sender)
	end
end

-- Eine allg. Suchanfrage wurde rausgegeben und nun melden sich die Member einfach
-- alles weitere geht dann ihre normalen Wege
function MDB_Event:search(Message, Sender)
	-- Wenn ich bereits in einer echten Gruppe bin, darf der Dungeonbrowser die nicht auseinander reißen
	if GetNumPartyMembers() > 0 then return end

	local DungeonForQueue = {}
	for id in pairs(Message) do
		if MDB.Dungeons[id] then
			table.insert(DungeonForQueue, id)
		end
	end

	-- Keine Dungeon gesucht, in der ich auch angemeldet bin
	if #DungeonForQueue == 0 then return end

	-- wenn doch was dabei ist, tue ich einfach mal so, als ob ich gerade beigetreten bin
	DungeonForQueue = table.concat(DungeonForQueue, ",")
	MDB_Prototype:Send("join", MDB_Prototype:ConvertPlayerInfo("myself")..","..DungeonForQueue, Sender)
end

-------------------------------------
---- interne Operation --------------
-------------------------------------

function MDB_QueueUpdate()
	-- läuft nur los, wenn man auch im queue ist
	if MDB.ActiveDungeonID ~= 0 and MDB.Dungeons[MDB.ActiveDungeonID].Status ~= "queue" then
		return 
	end

	-- der am besten gefüllte Queue wird als "aktuell" gesetzt
	local PlayerCount = 0
	MDB.ActiveDungeonID = 0

	for id,Dungeon in pairs(MDB.Dungeons) do
		if Dungeon:GetPlayerCount() > PlayerCount then
			PlayerCount = Dungeon:GetPlayerCount()
			MDB.ActiveDungeonID = id
			if PlayerCount == Dungeon.MaxPlayer then
				MDB.Dungeons[MDB.ActiveDungeonID]:RoleArrange()
				MDB.Dungeons[MDB.ActiveDungeonID]:StartRdyCheck()
				debugprint("Gruppe vollständig: "..id)
				return
			end
		end
	end

	-- Keine aktive Dungeon
	if MDB.ActiveDungeonID == 0 then return end
	MDB.Dungeons[MDB.ActiveDungeonID]:RoleArrange()
	LFGEventFrame_OnEvent(LFGEventFrame, "LFG_QUEUE_STATUS_UPDATE")
end

function MDB_Disabled()
	LeaveLFG()

	MDB.Enable = false
	MDB_SystemMessage("Mangos-DungeonBrowser: "..ADDON_DISABLED)
end

function MDB_CreateCustomLockList()
	MDB.CustomLockList = {}

	if GetNumPartyMembers() == 0 then
		return
	end

	-- Die Levelrange für eine Dungeon wird hier ermittelt
	local MinLevel = UnitLevel("player")
	local MaxLevel = UnitLevel("player")

	for num = 1, GetNumPartyMembers() do
		if MinLevel > UnitLevel("party"..num) then
			MinLevel = UnitLevel("party"..num)
		end
		if MaxLevel < UnitLevel("party"..num) then
			MaxLevel = UnitLevel("party"..num)
		end
	end

	-- Nun werden alle Dungeons mit der Levelrange verglichen und
	-- alle nicht zulässigen Dungeons werden in die Locklist geworfen
	-- leider kann ich nicht das expensionpack der mitspieler vergleichen
	for id in pairs(GetLFDChoiceInfo()) do
		if MDB_DungeonLock(id, MinLevel, MaxLevel) then
			MDB.CustomLockList[id] = 1
		end
	end
end

function MDB_DungeonLock(DungeonID, MinLevel, MaxLevel)
	if MDB.CustomLockList[DungeonID] or MDB.LockList[DungeonID] then
		return 1
	end

	local Dungeon = {GetLFGDungeonInfo(DungeonID)}
	MaxLevel = MaxLevel or MinLevel
	if not Dungeon[LFG_RETURN_VALUES.minLevel] or MinLevel < Dungeon[LFG_RETURN_VALUES.minLevel] or MaxLevel > Dungeon[LFG_RETURN_VALUES.maxLevel] then
		return 1
	end
end
